<?php 

/**
 Pluginbuilder Controller
 
 @Copyright 2016 Stefan Rick
 @author Stefan Rick
 Mail: stefan@rick-software.de
 Web: http://www.netzberater.de

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License along
 with this program; if not, write to the Free Software Foundation, Inc.,
 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */


class Pluginbuilder_Edit extends Service {
		
	public $scriptPath = '';		
	
	public function __construct(){
		parent::__construct();				
		
		$this->scriptPath = dirname(__FILE__).'/../scripts/';
		
		$this->_installCodeMirror();
		
		$this->getCode();
		
		//If Button clicked or Form sent do Something
		if(isset($_REQUEST['action'])){
			if($_REQUEST['save'] == 'save'){
				$this->_saveCode();			
			}
						
		}
		
		$this->showHelpSidebar();
		//Get Debug Info
		$this->_getAllLogs();
	}		
	
	private function _installCodeMirror(){
		$install_from_source = false;
		if(!file_exists('/var/www/max2play/public/addons/codemirror')){
			$this->view->message[] = _t('Code Mirror will now be installed (Editor). Reload page once finished to clear the install message.');
			if($install_from_source)
				$this->view->message[] = nl2br($this->writeDynamicScript(array('wget http://codemirror.net/codemirror.zip -O /opt/max2play/cache/codemirror.zip', 				
					'unzip /opt/max2play/cache/codemirror.zip -d /var/www/max2play/public/addons/',
					'mv /var/www/max2play/public/addons/codemirror-* /var/www/max2play/public/addons/codemirror')));
			else
				$this->view->message[] = nl2br($this->writeDynamicScript(array('unzip '.$this->scriptPath.'codemirror.zip -d /var/www/max2play/public/addons/')));
			$this->view->message[] = _t('Code Mirror installed (Editor)');
		}
		return true;
	}
	
	public function getCode(){
		$pluginname = $_REQUEST['createdPlugins'];
		$this->view->pluginname = $pluginname;
		$this->view->action = $_REQUEST['action'];						
		
		if($_REQUEST['action'] == 'editview')
			$this->view->filename = APPLICATION_PATH.'/plugins/'.($pluginname).'/view/setup.php';
		elseif($_REQUEST['action'] == 'editcontroller')
			$this->view->filename = APPLICATION_PATH.'/plugins/'.($pluginname).'/controller/Setup.php';
		elseif($_REQUEST['action'] == 'editinstallscript')
			$this->view->filename = APPLICATION_PATH.'/plugins/'.($pluginname).'/scripts/install.sh';
		elseif($_REQUEST['action'] == 'editmyscript')
			$this->view->filename = APPLICATION_PATH.'/plugins/'.($pluginname).'/scripts/myscript.sh';
		elseif($_REQUEST['action'] == 'editsystemd'){
		    if(!file_exists(APPLICATION_PATH.'/plugins/'.($pluginname).'/scripts/'.$pluginname.'.service')){
		        $this->shell_exec('cp '.$this->scriptPath.'example.service '.APPLICATION_PATH.'/plugins/'.($pluginname).'/scripts/'.$pluginname.'.service');
		        $this->shell_exec('sed -i "s@\$PLUGINNAME@'.$pluginname.'@" '.APPLICATION_PATH.'/plugins/'.($pluginname).'/scripts/'.$pluginname.'.service');
		    }
		    $this->view->filename = APPLICATION_PATH.'/plugins/'.($pluginname).'/scripts/'.$pluginname.'.service';		
		}elseif(strpos($_REQUEST['action'], 'editcustomfile') !== FALSE){
			$file = explode('|', $_REQUEST['action']);
			$this->view->filename = APPLICATION_PATH.'/plugins/'.($pluginname).'/'.$file[1];
		}
		
		$this->view->editfile = str_replace('</textarea>','<//textarea>', file_get_contents($this->view->filename));
		return true;
	}
	
	private function _saveCode(){
		if(file_put_contents($_REQUEST['filename'],str_replace(array('<//textarea>',"\r"),array('</textarea>', ''),$_REQUEST['edit']))){			
			$this->view->message[] = _t('File saved').': <a href="/plugins/'.$this->view->pluginname.'/controller/Setup.php" target="_blank">Open Plugin Page Now (test it)</a>';
			// Set execute / access rights
			$this->writeDynamicScript(array('chmod 777 '.$_REQUEST['filename']));
			// Optional use Dos2Unix Conversion to strip ^M from lines
			// tr -d '\r' <$file >temp.$$ && mv temp.$$ $file && chmod 777 $file
		}else{
			$this->view->message[] = _t('Error saving File');
		}
		$this->getCode();
		return true;
	}
	
	private function _getAllLogs(){		
		$out = array();
		$this->view->debug = $out;
	}
	
	public function showHelpSidebar(){
		global $helpSidebar;
		$helpSidebar['title'] = _t('Help - Edit Files');
		$helpSidebar['content'] = _t('<ul><li>Build your Plugin with Max2Play - Find HowTos in our developer corner.</li><li>A plugin basically consists of a controller file (application logic) and a view file (HTML generation).</li></ul>');		
		return true;
	}
}

$edit = new Pluginbuilder_Edit();

include_once(dirname(__FILE__).'/../view/edit.php');

