<?php
/**
	Pluginbuilder View File
	
	 @Copyright 2016 Stefan Rick
	 @author Stefan Rick
	 Mail: stefan@rick-software.de
 	 Web: http://www.netzberater.de
	
	 This program is free software; you can redistribute it and/or modify
	 it under the terms of the GNU General Public License as published by
	 the Free Software Foundation; either version 2 of the License, or
	 (at your option) any later version.
	
	 This program is distributed in the hope that it will be useful,
	 but WITHOUT ANY WARRANTY; without even the implied warranty of
	 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	 GNU General Public License for more details.
	
	 You should have received a copy of the GNU General Public License along
	 with this program; if not, write to the Free Software Foundation, Inc.,
	 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */ 
?>											


<h1 class="entry-header">
	<?php echo _("Pluginbuilder") ?>
</h1>
<div class="entry-content">
	<?php if(isset($builder->view->message[0])){ ?>
		<div class="ui-widget">
			<div class="ui-state-highlight ui-corner-all" style="margin-bottom: 10px; padding: 0.4em .7em;">
				<p>
					<span class="ui-icon ui-icon-info" style="float: left; margin-right: .3em;"></span>
					<?php echo implode('<br />', $builder->view->message); ?>					
				</p>
			</div>
		</div>
	<?php } ?>
	
	<p class="ui-state-default ui-corner-all" style="padding:4px;margin-bottom:1em;">
			<span class="ui-icon ui-icon-wrench" style="float:left; margin:-2px 5px 0 0;"></span>
			<b><?php echo _t("Create your own Max2Play-Plugins") ?></b></p>
		
	<br />	
	<?php echo _t('Use Max2Play to build a custom web interface with your ideas. Create an interface to start/stop services, configure and set up tasks, modify config scripts. Once finished, easily share your Plugin with others!')?>
	<br /><br />	
	
	<form action="" method="get" id="form1">
		<input type="hidden" id="action" name="action" value="" />			
		
		
		<div id="pluginbuilder" style="max-height:500px;">
		  <h3><?php echo _t('Your created Plugins') ?></h3> 
		  <div>
		    <p>
		    	<?php echo _t("Choose plugin from list to work with") ?>:
		    	<select name="createdPlugins" onchange="fetchCustomFiles(this);">
					<?php foreach($builder->view->customplugins as $plugin) {?>
						<option value="<?php echo $plugin['folder']?>"><?php echo $plugin['name']?></option>
					<?php } ?>
				</select><br /><br />
				<input type="button" value="<?php echo _t('Edit Controller File') ?>" onclick="document.getElementById('action').value='editcontroller';document.getElementById('form1').action='/plugins/pluginbuilder/controller/Edit.php';submit();" />&nbsp;
				<input type="button" value="<?php echo _t('Edit View File') ?>" onclick="document.getElementById('action').value='editview';document.getElementById('form1').action='/plugins/pluginbuilder/controller/Edit.php';submit();" />&nbsp;
				<select name="editmore" id="editmore" style="width:120px;" onchange="loadEditorWithFile(this);">
					<option value="other Files"><?php echo _t('Edit other files') ?></option>
					<option value="installscript"><?php echo _t('Edit Install Script (Shell)') ?></option>
					<option value="myscript"><?php echo _t('Edit MyScript (Shell)') ?></option>
					<option value="systemd"><?php echo _t('Add Systemd Startscript (Autostart)') ?></option>
				</select>
				<input type="button" value="<?php echo _t('Download') ?>" onclick="document.getElementById('action').value='download';submit();"/>&nbsp;
				<?php /*<input type="button" value="<?php echo _t('Upload to Max2Play Website') ?>" onclick="document.getElementById('action').value='upload';submit();"/>&nbsp;*/?>
				<input type="button" value="<?php echo _t('Delete') ?>" onclick="if(!confirm('Are you sure you want to delete this item?'))  {setTimeout(function(){ $('body').removeClass('loading'); }, 500);return false;}document.getElementById('action').value='delete';submit();"/>
				<br /><br />
				<?php echo _t("The Plugins do have a controller file (PHP code) and a view file (mixed PHP and HTML code). Have a look at the comments within the example to get startet and check out the developer corner on Max2Play.com for tutorials.") ?>	    
		    </p>
		  </div>
		  <h3><?php echo _t("Create new Plugin") ?></h3>
		  <div>
		    <p>
		    	<?php echo _t("Create a new Plugin by making a copy of the Example Plugin. This creates a controller and view file within a separate plugin folder. If you are looking for some basic functionality, this is the easiest way to start. You may also add shell-scripts, translations and other things later (this is not part of the Pluginbuilder yet).") ?>
		    	<br /><br />
		    	<?php echo _t("Choose name") ?>: <input type="text" name="pluginname" />
				<br />
			
				<input type="button" id="save" name="<?php echo _("save") ?>" onclick="document.getElementById('action').value='createPlugin';submit();" value="<?php echo _("save") ?>" />
		    
		    </p>
		  </div>		  
		</div>	
	
	 <script>
	  $(function() {
	    $( "#pluginbuilder" ).accordion({
	      heightStyle: "content",	      
	      collapsible: true 
	    });   
	  });  
 	 </script>
	 
	 <script>	 
		function loadEditorWithFile(item){
			filename=item.options[item.selectedIndex].value;
			document.getElementById('action').value='edit'+filename;
			document.getElementById('form1').action='/plugins/pluginbuilder/controller/Edit.php';
			document.getElementById('form1').submit();
		}
		
	 	function fetchCustomFiles(item){
	 		plugin=item.options[item.selectedIndex].value;
	 		$("body").addClass("loading");
	 		$('#editmore option[class=dyn]').remove();
	 		$.ajax({
	 			  method: "POST",
	 			  url: "Setup.php",
	 			  data: { action: "getcustomfiles", ajax: "1", pluginname: plugin },
	 			  dataType : "json" 
	 			}).done(function(items) {
	 			  //alert( "Data Saved: " + items );
	 			  $("body").removeClass("loading");
	 			  $.each(items, function (i, item) {
	 				    $('#editmore').append($('<option>', { 							
	 				        value: 'customfile|' + item.value,
	 				        text : item.text,
	 				        //onclick: "$('#action').val('editcustomfile|"+ item.value +"');$('#form1').attr('action', '/plugins/pluginbuilder/controller/Edit.php');$('#form1').submit();",
	 				        class: 'dyn', 
	 				    }));
	 				});
	 			});
	 	}				
	 </script>
	 			
	</form>
	<br /><br />
	<?php echo _t("<b>How to share your custom Plugin with a few people</b>: download and save locally on your computer. Send the file by mail or offer it as download. Everyone can download and easily install your plugin with the Plugin-Installer on the Settings page of Max2Play.") ?>
	<br /><br />
	<?php echo _t("<b>How to share your custom Plugin with ALL Max2Play users</b>: Send your Plugin with a small description to us and we will check it and put it on the Max2Play-Website.") ?>
	<br /><br />
	<?php echo _t("<b>Access Max2Play via SSH and Console</b>: More customizing options and script editing with SSH and console access from this web interface with the Max2Play Plugin <a href='https://www.max2play.com/en/portfolio/plugin-remote-control/' target=_blank>Remote Control</a>.") ?>
	<br /><br />
	<a href="#javascript" onclick="document.getElementById('debug').style.display='';return false;"><?php echo _("DEBUG Informations") ?></a>
	<textarea id="debug" rows="30" cols="70" style="display:none;"><?php foreach ($builder->view->debug as $key => $debug) {
			echo "#### ". $key. " ####\n"; 
			 echo $debug." \n\n"; 
		 }?>
	</textarea>
</div>	